unit upaint2ObjBase;

{$MODE Delphi}

interface

uses
  LCLIntf,SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Tools,StdCtrls,uPaint2Object,uPaint2Raster;

const
  nul1              = 0;
  None              = -1;
  alt_Line          = 0;
  alt_Dreieck       = 1;
  alt_Vireck        = 2;
  alt_kreis         = 3;
  alt_Text          = 4;
  alt_Poligon       = 5;
  alt_agr           = 6; // abgerundes Reckeck

  Neu_Line          = 30;
  Neu_Dreieck       = 31;
  Neu_Vieck         = 32;
  Neu_Kreis         = 33;
  Neu_Text          = 34;
  Neu_Poligon       = 35;
  Neu_agr           = 36; // abgerundes Recheck

  Allgemein_cf      = 60; // Farbfller;
  Allgemein_cp      = 61; // Farbfinder
  
  Extras_ImageListA = 80;
  Extras_ImageListB = 81;

type
  TPaint2BasesObj = class;

  TonAddDaten = procedure(var list:TStringList) of Object;
  TonChangeObj = procedure(Newobj:TPaint2BasesObj) of object;
  

  TPoint2 = class(TPersistent)
  private
    fx,fy:Integer;
  published
    property x:integer read fx write fx;
    property y:Integer read fy write fy;

  end;


  TPaint2BasesObj = class(TPaint2Object)
  protected
    fRaster:TPaint2Raster;
  
    stdObj:TPaint2BasesObj;
    fPosition,FSize:TPoint2;

    fBrush:TBrush;
    fPen:TPen;
    fFont:TFont;
    fVisible,fsel:Boolean;
    buffer1:TBitMap;
    SizePoint:array of Trect;
    fPointModus:Integer;
    fFest:Boolean;
    fMoved:Boolean;
    oldBuffer:TBitmap;
    procedure SetPosition(Value:TPoint2);
    procedure SetSize(Value:TPoint2);

    procedure SetBrush(value:TBrush);
    procedure SetPen(value:TPen);
    procedure SetFont(Value:TFont);
    procedure SetVisible(Value:Boolean);
    function GetPosition:TPoint2;
    function GetSize:TPoint2;
    function GetBrush:TBrush;
    function GetPen:Tpen;
    function GetFont:TFont;
    function GetVisible:Boolean;
    procedure SetObjTyp(Value:Integer);
    function GetobjTyp:Integer;
    procedure SetSel(Value:Boolean);
    function GetSel:Boolean;
    function GetPointsModus:Integer;
    procedure SetPointsModus(Value:Integer);
    procedure SetMoved(Value:Boolean);
    procedure SetName(Value:String);override;
  published
    property Position:TPoint2 read GetPosition write SetPosition;
    property Size:TPoint2 read GetSize write SetSize;

    property Brush:TBrush read GetBrush write SetBrush;
    property Pen:TPen read GetPen write SetPen;

    property Font:TFont read GetFont write SetFont;
    property Visible:Boolean read GetVisible write SetVisible;
    property fest:Boolean read fFest write fFest default False;
    property Raster:TPaint2Raster read fRaster write fRaster;

  public
    oldbrush:TBrush;
    oldpen:TPen;

    fTyp:integer;
    pointDrawMove,pointDrawDown:Integer;
    onChangeobj:TonChangeObj;

    changePos:TPoint2;
    changeSize:TPoint2;

    property isMoved:Boolean read fMoved write SetMoved;
    property Typ:Integer read GetobjTyp write SetObjTyp;
    property PointsModus:Integer read getPointsModus write SetPointsModus;
    property Sel:Boolean read GetSel write SetSel;
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean);virtual;
    procedure SetSizePointIndex(x,y:Integer;Shfit:TShiftState);
    procedure ChangeSizeObj(x,y:Integer); 
  end;
    function pointTOTPoint2(x,y:Integer):TPoint2;

implementation


function pointTOTPoint2(x,y:Integer):TPoint2;
var
  v:TPoint2;
begin
  v:=TPoint2.Create;
  v.x:=x; v.y:=y;
  result:=v;
end;

procedure TPaint2BasesObj.SetName(Value:String);
begin
  inherited;
  if Assigned(onChangeobj)then onChangeobj(self)
end;

procedure TPaint2BasesObj.SetMoved(Value:Boolean);
begin

//  if (Value = False) and (isMoved = True) then begin
//    position.x:=changePos.x;
//    position.y:=changePos.y;
//  end;

  fMoved:=Value;

end;

procedure TPaint2BasesObj.ChangeSizeObj(x,y:Integer);
begin

  if pointDrawDown = 0 then begin // Oben lings
    position:=pointTOTPoint2(x,y);
  end;

  if pointDrawDown = 1 then begin // Untere Lings
    position:=pointTOTPoint2(x,position.y);
    size:=pointTOTPoint2(size.x,y);
  end;

  if pointDrawDown = 2 then begin // Untere Rechts
    size:=pointTOTPoint2(x,y);
  end;

  if pointDrawDown = 3 then begin // Oben Rechts
    size:=pointTOTPoint2(x,size.y);
    position:=pointTOTPoint2(position.x,y);
  end;

  if pointDrawDown = 4 then begin // Oben mitte
    position:=pointTOTPoint2(position.x,y);
  end;

  if pointDrawDown = 5 then begin // Unten mitte
     size:=pointTOTPoint2(size.x,y);
  end;

  if pointDrawDown = 6 then begin // Lings mitte
    position:=pointTOTPoint2(x,position.y);
  end;

  if pointDrawDown = 7 then begin // Rehcts mitte
    size:=pointTOTPoint2(x,size.y);
  end;
end; // ChangeSizeOBj

procedure TPaint2BasesObj.SetSizePointIndex(x,y:Integer;Shfit:TShiftState);
var
  i,t:integer;
begin
  if self <> NIl then begin
    t:=-1;
    for i:=0 to High(SizePoint) do begin
      if PtInRect(SizePoint[i],Point(x,y)) = true then begin
        t:=i;
        break;
      end;
    end;

    if ssleft in Shfit then begin
      if t > -1 then
      pointDrawDown:=t;
    end
    else
      pointDrawMove:=t
  end;
end; // SetSizePointIndex

procedure TPaint2BasesObj.SetSel(Value:Boolean);
begin
  fsel:=Value;
end; // SetSel

function TPaint2BasesObj.GetSel:Boolean;
begin
  result:=fsel;
end; // GetSel

function GetText(D:TStringList;wert:String;index:Integer;var l:Integer;isUser:Boolean = False):String;
var
  i:integer;
  str:String;
begin
  for i:=0 to d.Count-1 do begin
    if Trim(UpperCase(GetToken(d.Strings[i],'=',index))) = UpperCase(wert) then begin
      l:=i;
      if isUser = False then
        str:=GetToken(d.Strings[i],'=',3)
      else
        str:=d.Strings[i];
      break;
    end;
  end;
  result:=str;
end;


procedure TPaint2BasesObj.SetObjTyp(Value:Integer);
begin
  fTyp:=Value;
end;

function TPaint2BasesObj.GetobjTyp:Integer;
begin
  result:=fTyp
end;

function TPaint2BasesObj.GetVisible:Boolean;
begin
  result:=fVisible;
end;

procedure TPaint2BasesObj.SetVisible(Value:Boolean);
begin
  fVisible:=Value;
  if Assigned(onChangeobj)then onChangeobj(self)
end;


constructor TPaint2BasesObj.Create(value:TBitMap);
begin
  fraster:=TPaint2Raster.Create;

  fPosition:=TPoint2.Create; fSize:=TPoint2.Create;
  fFont:=Tfont.Create;fpen:=TPen.Create; fBrush:=TBrush.Create;
  SetLength(SizePoint,8); pointDrawMove:=-1; pointDrawDown:=-1;

  oldbrush:=TBrush.Create;
  oldpen:=TPen.Create;

  oldbrush.Assign(Value.canvas.Brush);

  oldpen.Assign(Value.Canvas.Pen);
  isMoved:=False; changePos:=TPoint2.Create; changeSize:=TPoint2.Create;
  oldBuffer:=TBitmap.Create;

end; // Create

procedure TPaint2BasesObj.SetPosition(Value:TPoint2);
begin
  //if isMoved = false then
    fPosition:=value;
//  else
  //  ChangePos:=value;
    
  if Assigned(onChangeobj)then onChangeobj(self)
end; // SetPosition

procedure TPaint2BasesObj.SetSize(Value:TPoint2);
var
  tx,ty:Integer;
  b:TBitmap;
begin

  if (raster.AutoObjectSizeChange = false) or (isMoved = true) then
    fSize:=Value
  else begin
    b:=niL;
//    tx:=(value.x-position.x)-(round(((value.x-position.x) / raster.rx))+(tx*raster.rx));
//    ty:=(value.y-position.y)-(round(((value.y-position.y) / raster.ry))+(ty*raster.ry));
    tx:=((round(((value.x) / raster.rx) * raster.rx)));
    
    ty:=value.y;
    fsize.x:=tx;
    fsize.y:=ty;
//    Draw(b,true);
//    raster.Draw(position.x,position.y,fsize.x,fsize.y,b,oldpen,oldbrush);
  end;
  
  if Assigned(onChangeobj)then onChangeobj(self)
end; // SetSize


procedure TPaint2BasesObj.SetBrush(value:TBrush);
begin
  fbrush:=Value;
end; // SetBrush

procedure TPaint2BasesObj.SetPen(value:TPen);
begin
  fpen:=value;
end; // SetPen

procedure TPaint2BasesObj.SetFont(Value:TFont);
begin
  FFont:=Value
end; // SetFont

function TPaint2BasesObj.GetPosition:TPoint2;
begin
  if fPosition = nil then fPosition:=Tpoint2.create;
//  if changePos = nil then changePos:=Tpoint2.create;

  //if isMoved = False then
    result:=fPosition;
//  else
  //  result:=ChangePos;
end; // GetPosition

function TPaint2BasesObj.GetSize:TPoint2;
begin
//  if isMoved = False then
    result:=fSize;
//  else
  //  result:=ChangeSize;
end; // GetSize

function TPaint2BasesObj.GetBrush:TBrush;
begin
  result:=fbrush;
end; // GetBrush

function TPaint2BasesObj.GetPen:TPen;
begin
  result:=fPen;
end; // GetPen

function TPaint2BasesObj.GetFont:TFont;
begin
  result:=fFont;
end; // GetFont

function TPaint2BasesObj.GetPointsModus:Integer;
begin
  result:=fPointModus;
end; // GetPointsModus

procedure TPaint2BasesObj.SetPointsModus(Value:Integer);
begin
  fPointModus:=Value;
end; // SetPointsModus

procedure TPaint2BasesObj.Draw(var buffer:TBitMap;fissel:Boolean);
var
  t,px,sx,py,sy:Integer;
begin
    if buffer = nil then
      buffer:=oldbuffer
    else
      oldbuffer:=buffer;

   if fisSel =  true then begin
     px:=Position.x-((pen.Width div 2)+1);
     py:=position.y-((pen.Width div 2)+1);
     sx:=Size.x+((pen.Width div 2)+1);
     sy:=size.y+((pen.Width div 2)+1);
     if fPointModus = 0 then begin

       SizePoint[0]:=Rect(px-4,py-4,px,py); // Lings oben
       SizePoint[1]:=Rect(px-4,sy,px,sy+4); // Linx Unten

       SizePoint[2]:=Rect(sx,sy,sx+4,sy+4); // rechts unten
       SizePoint[3]:=Rect(sx,py-4,sx+4,py); // rechts oben
       SizePoint[4]:=Rect(px+((sx-px-4) div 2),py-4,px+((sx-px-4) div 2)+4,py); // oben mitte
       SizePoint[5]:=Rect(px+((sx-px-4) div 2),sy,px+((sx-px-4) div 2)+4,sy+4); // unten mitte
       SizePoint[6]:=Rect(px-4,(py+((sy-py+4) div 2))-4,px,(py+((sy-py+4) div 2))); // Lings mitte
       SizePoint[7]:=Rect(sx,(py+((sy-py+4) div 2))-4,sx+4,(py+((sy-py+4) div 2))); // Rechts mitte
     end;

     if fPointModus = 1 then begin
       SizePoint[0]:=Rect(px-4,position.y-4,px,position.y); // Lings oben
       SizePoint[2]:=Rect(sx,size.y,sx+4,size.y+4); // rechts unten
     end;


     for t:=0 to High(SizePoint) do begin
       if t = pointDrawMove then begin
         Buffer.Canvas.Pen.Color:=clRed;
         Buffer.Canvas.brush.Color:=clRed
       end
       else begin
         Buffer.Canvas.brush.Color:=clYellow;
         Buffer.Canvas.Pen.Color:=clYellow;
       end;
       Buffer.Canvas.Rectangle(SizePoint[t] );
     end;
    end;
    Buffer.Canvas.Pen:=Pen;
    Buffer.Canvas.Brush:=Brush;
end; // Draw,


end.
