unit upaint2main;

{$mode objfpc}{$H+}

interface

uses
  LCLIntf,  SysUtils, Classes, Graphics, Controls, uliste,Forms,
  Dialogs, ExtCtrls, StdCtrls,uPaint2Obj,RTTIGrids,inifiles,uPaint2Object,upaint2ObjBase;
  
type
  tonAddObj = procedure(obj:TPaint2BasesObj) of Object;
  TonChangeObj = procedure(Newobj:TPaint2BasesObj) of object;
  tOnSizeChange = procedure(NW,NH:integer) of object;
  tDeleteObj = procedure(index:Integer) of object;

  { TPaint2Main }

  TPaint2Main = class
  private
    buffer:TBitMap;
    fPen:TPen;
    fBrush:TBrush;
    fPaintBox:TPaintBox;
    function Getbrush: TBrush;
    function GetPen: TPen;
    function GetSize: TPoint2;
    procedure SetBrush(const AValue: TBrush);
    procedure SetPen(const AValue: TPen);
    procedure SetSize(const AValue: TPoint2);
    procedure ChangeBGSize(Newobj:TPaint2BasesObj);
  public
    liste:TmyList;
    onAddObj:tonAddObj;
    onChangeobj:TonChangeObj;
    onChangeSize:tOnSizeChange;
    onDeleteObj:tDeleteObj;
    bg:Tbg;
    ti,tc:Integer;
    procedure Clear;
    constructor Create(flistbox:TListBox;oi:TTIPropertyGrid;PaintBox:TPaintBox;w,h:Integer);
    procedure AddObj(toolindex,x,y,w,h:integer);
    procedure DrawObj(t:Boolean = false);
    procedure Flip;
    procedure DelSelObj;
    procedure LoadVorlage(FileName:TFileName;obj:TPaint2BasesObj);
    procedure SaveVorlage(FileName:TFileName;obj:TPaint2BasesObj);

  published
    property Size:TPoint2 read GetSize write SetSize;
    property Brush:TBrush read Getbrush write SetBrush;
    property Pen:TPen read GetPen write SetPen;
  end;
  
implementation

uses uPaint2Raster;
{ TPaint2Main }

procedure TPaint2Main.ChangeBGSize(Newobj:TPaint2BasesObj);
begin

  fpaintbox.Width:=bg.size.x;
  fpaintbox.Height:=bg.size.y;
  bg.Name:='test1';

end;

procedure TPaint2Main.Clear;
begin
  Buffer.Width:=1; Buffer.Height:=1;
  fbrush.Color:=clRed;
  Buffer.Width:=fPaintBox.Width; Buffer.Height:=fPaintBox.Height;
end;

function TPaint2Main.GetSize: TPoint2;
var
  aValue:TPoint2;
begin
  aValue:=TPoint2.create;
  aValue.x:=buffer.Width;
  aValue.y:=buffer.Height;
  result:=aValue;
end; // GetSize

procedure TPaint2Main.SetSize(const AValue: TPoint2);
begin
  buffer.Width:=avalue.x; buffer.Height:=avalue.y;
  bg.Size.x:=buffer.Width-4;
  bg.Size.y:=buffer.Height-4;
  if Assigned(onChangeSize) then onChangeSize(AValue.x,AValue.y)
end; // SetSize

function TPaint2Main.Getbrush: TBrush;
begin
  result:=fbrush;
end;

procedure TPaint2Main.SetBrush(const AValue: TBrush);
begin
  fbrush.Assign(AValue);

end;

function TPaint2Main.GetPen: TPen;
begin
  result:=fPen;
end;

procedure TPaint2Main.SetPen(const AValue: TPen);
begin
  fpen.Assign(avalue);
end;

constructor TPaint2Main.Create(flistbox:TListBox;oi:TTIPropertyGrid;PaintBox: TPaintBox; w, h: Integer);
begin
  buffer:=TBitMap.Create;
  buffer.Width:=w; buffer.Height:=h;
  bg:=Tbg.Create(buffer);
  bg.Typ:=Backgrund;
  bg.Brush.color:=clBlue;
  bg.Pen.Style:=psSolid;
  bg.Visible:=true;
  bg.Position:=pointTOTPoint2(0,0);
  bg.size:=pointTOTPoint2(w-4,h-4);
  bg.PointsModus:=0;
  bg.pointDrawDown:=2;
  bg.Raster:=TPaint2Raster.create;
  bg.Raster.rx:=16; bg.Raster.ry:=16;
  bg.Raster.onChangeValue:=@flip;

  liste:=TmyList.Create(oi,buffer,bg);
  liste.usrListBox:=flistbox;
  liste.bg:=bg;
  fPen:=TPen.Create;
  fPen.color:=clYellow;
  fBrush:=TBrush.Create;
  fBrush.Color:=clLime;
  fPaintBox:=Paintbox;
  ti:=0; tc:=15;
//  bg.onChangeobj:=@ChangeBGSize;

end; // Create

procedure TPaint2Main.AddObj(toolindex,x,y,w,h: integer);
var
  pobj:TPaint2Object;
begin
  pobj:=liste.AddObj(toolindex);
  if pobj <> NIL then begin
    if toolindex < 80 then begin
      with TPaint2BasesObj(pobj) do begin

        Position:=pointTOTPoint2(x,y);
        Size:=pointTOTPoint2(w,h);
        if toolindex = alt_Line then
          PointsModus:=1
        else
          PointsModus:=0;

        typ:=toolindex;
        Name:=Name + IntTostr(liste.GetName(typ)+1);
        Brush.Color:=clLime;
        sel:=true;
        visible:=true;
        pointDrawDown:=2;
        Raster.rx:=16;         Raster.ry:=16;
        Raster.onChangeValue:=@Flip;
       if Assigned(onAddObj) then onAddObj(liste.selobject);
       if Assigned(onChangeobj) then onChangeobj(liste.selobject);
      end;
    end
    else begin
    liste.usrListBox.Items[liste.usrListBox.items.Count-1]:=liste.usrListBox.items[liste.usrListBox.items.Count-1] +IntTostr(liste.GetName(toolindex));
    end;

  end
  else
    WriteLN('Das Objekt: ' + IntTostr( toolindex) + #13#10'wird zur zeit noch nicht untersttzt !');

end; // AddObj

procedure Tpaint2Main.DrawObj(t:Boolean = false);
var
  i,sx,sy,px,py:integer;
begin
  clear;
  bg.Draw(buffer,false);
  bg.raster.Draw(bg.position.x,bg.position.y,bg.size.x,bg.size.y,buffer,bg.oldpen,bg.oldbrush);

  for i:=0 to liste.liste.Count-1 do begin
    with TPaint2BasesObj(liste.liste.Items[i]) do begin
      if Visible = True then begin
        if ((PointsModus = 0) and ((Sel = true) or (i = liste.itemindex))) then begin
          Buffer.Canvas.Pen.Style:=psDash;
          if i = liste.itemindex then
            Buffer.Canvas.Pen.Color:=clLime
          else
            Buffer.Canvas.Pen.Color:=clYellow;
    //      if TPaint2Obj(objList.Items[i])  is TLine = false then
          Buffer.Canvas.brush.Style:=bsClear;
          if position.x < size.x  then
            px:=Position.x-((pen.Width div 2)+1)
          else
            px:=Position.x+((pen.Width div 2)+1);

          if position.y < size.y then
            py:=position.y-((pen.Width div 2)+1)
          else
            py:=position.y+((pen.Width div 2)+1);

          if position.X < size.X   then
            sx:=size.x+((pen.Width div 2)+1)
          else
            sx:=size.x-((pen.Width div 2)+1);

          if  position.Y < size.Y  then
            sy:=size.y+((pen.Width div 2)+1)
          else
            sy:=size.y-((pen.Width div 2)+1);
          Buffer.Canvas.Rectangle(px,py,sx,sy);
        end;
        Draw(buffer,i = liste.itemindex);

      end; // visible
    end;
    if i = liste.itemindex then liste.GetPaint2Obj(i).Draw(buffer,true);
    TPaint2BasesObj(liste.liste.Items[i]).Raster.Draw(TPaint2BasesObj(liste.liste.Items[i]).position.x,TPaint2BasesObj(liste.liste.Items[i]).position.y,TPaint2BasesObj(liste.liste.Items[i]).size.x,TPaint2BasesObj(liste.liste.Items[i]).size.y,buffer,TPaint2BasesObj(liste.liste.Items[i]).oldpen,TPaint2BasesObj(liste.liste.Items[i]).oldbrush);
  end;
  
  if t = false then
    flip
  else begin
    if ti >= tc then begin
      flip;
      ti:=0;
    end
    else
      inc(ti);
    
  end;
end; // DrawObj

procedure Tpaint2Main.Flip;
begin
  BitBlt(fPaintBox.Canvas.Handle,0,0,buffer.Width,buffer.Height,buffer.canvas.Handle,0,0,fPaintBox.Canvas.CopyMode);
end;

procedure Tpaint2Main.DelSelObj;
begin
  liste.DeleteObject(-2);
  Drawobj;
  if Assigned(onDeleteObj) then onDeleteObj(liste.itemindex);
  if Assigned(onChangeobj) then onChangeobj(liste.selobject);

end;

procedure Tpaint2Main.LoadVorlage(FileName:TFileName;obj:TPaint2BasesObj);
var
  Emty:TIniFile;
begin
  Emty:=TIniFile.Create(FileName);
  if obj <> nil then begin
    with Emty do begin
      obj.Brush.Color:=StringToColor(ReadString('obj','Brush.Color',''));
      obj.Brush.Style:=TBrushStyle(ReadInteger('obj','Brush.Style',0));

      obj.Pen.Color:=StringToColor(ReadString('obj','Pen.Color',''));
      obj.Pen.Style:=TPenStyle(ReadInteger('obj','Pen.Style',0));

      obj.Pen.Width:=ReadInteger('obj','Pen.Width',0);
    end;
  end;
  Emty.free;
end;

procedure Tpaint2Main.SaveVorlage(FileName:TFileName;obj:TPaint2BasesObj);
var
  Emty:TIniFile;
begin
  Emty:=TIniFile.Create(FileName);
  if obj <> nil then begin
    with Emty do begin
      WriteString('obj','Brush.Color',ColorToString(obj.Brush.Color));
      WriteInteger('obj','Brush.Style',integer(obj.Brush.Style));

      WriteString('obj','Pen.Color',ColorToString(obj.Pen.Color));
      WriteInteger('obj','Pen.Style',integer(obj.Pen.Style));
      WriteInteger('obj','Pen.Width',integer(obj.Pen.Width));

    end;
  end;
  Emty.free;
end;

end.

